use std::ops::Deref;

use rocket::{http::CookieJar, State};
use rocket_dyn_templates::{context, Template};

use crate::models::{Challenge, User, Settings};

#[get("/<challenge>")]
pub async fn get_challenge(challenge: u32, cookies: &CookieJar<'_>, settings: &State<Settings>) -> Template {
    println!(
        "{:?}",
        cookies
            .get_private("user_name")
            .map(|cookie| cookie.value().to_owned())
    );
    Template::render(
        "index",
        context! {
            challenge,
            settings: settings.deref(),
            user: User::get(cookies).await.unwrap(),
            content: Challenge::get(challenge),
        },
    )
}
